export declare type ValueParser<Value> = (context: Context) => {
    get: string;
    put: string;
};
export declare const uint8: ValueParser<number>;
export declare const uint16be: ValueParser<number>;
export declare const uint16le: ValueParser<number>;
export declare const uint32be: ValueParser<number>;
export declare const uint32le: ValueParser<number>;
export declare const int8: ValueParser<number>;
export declare const int16be: ValueParser<number>;
export declare const int16le: ValueParser<number>;
export declare const int32be: ValueParser<number>;
export declare const int32le: ValueParser<number>;
export declare const boolean: ValueParser<boolean>;
export declare function skip(bytesToSkip?: number): ValueParser<{}>;
export declare function writeOnly<V extends string | number>(writer: ValueParser<V>, value: V): ValueParser<{}>;
export interface Context {
    output: string;
    input: string;
    availableVariables: string[];
}
export declare const array: <Value>(opts: {
    length: number | ValueParser<number>;
    of: ValueParser<Value>;
}) => ValueParser<Value[]>;
export declare const string: (length: ValueParser<number>, encoding?: string) => ValueParser<string>;
export declare const transform: <Input, Output>(v: ValueParser<Input>, to: (val: Input) => Output, from: (val: Output) => Input) => ValueParser<Output>;
export declare function field<N extends string, V extends string | number | boolean>(name: N, value: V): ValueParser<{
    [name in N]: V;
}>;
export declare function field<N extends string, V>(name: N, value: ValueParser<V>): ValueParser<{
    [name in N]: V;
}>;
export declare function record<V1>(field1: ValueParser<V1>): ValueParser<V1>;
export declare function record<V1, V2>(field1: ValueParser<V1>, field2: ValueParser<V2>): ValueParser<V1 & V2>;
export declare function record<V1, V2, V3>(field1: ValueParser<V1>, field2: ValueParser<V2>, field3: ValueParser<V3>): ValueParser<V1 & V2 & V3>;
export declare function record<V1, V2, V3, V4>(field1: ValueParser<V1>, field2: ValueParser<V2>, field3: ValueParser<V3>, field4: ValueParser<V4>): ValueParser<V1 & V2 & V3 & V4>;
export declare function record<V1, V2, V3, V4, V5>(field1: ValueParser<V1>, field2: ValueParser<V2>, field3: ValueParser<V3>, field4: ValueParser<V4>, field5: ValueParser<V5>): ValueParser<V1 & V2 & V3 & V4 & V5>;
export declare function record<V1, V2, V3, V4, V5, V6>(field1: ValueParser<V1>, field2: ValueParser<V2>, field3: ValueParser<V3>, field4: ValueParser<V4>, field5: ValueParser<V5>, field6: ValueParser<V6>): ValueParser<V1 & V2 & V3 & V4 & V5 & V6>;
export declare function record<V1, V2, V3, V4, V5, V6, V7>(field1: ValueParser<V1>, field2: ValueParser<V2>, field3: ValueParser<V3>, field4: ValueParser<V4>, field5: ValueParser<V5>, field6: ValueParser<V6>, field7: ValueParser<V7>): ValueParser<V1 & V2 & V3 & V4 & V5 & V6 & V7>;
export declare function record<V1, V2, V3, V4, V5, V6, V7, V8>(field1: ValueParser<V1>, field2: ValueParser<V2>, field3: ValueParser<V3>, field4: ValueParser<V4>, field5: ValueParser<V5>, field6: ValueParser<V6>, field7: ValueParser<V7>, field8: ValueParser<V8>): ValueParser<V1 & V2 & V3 & V4 & V5 & V6 & V7 & V8>;
export declare function record<V1, V2, V3, V4, V5, V6, V7, V8, V9>(field1: ValueParser<V1>, field2: ValueParser<V2>, field3: ValueParser<V3>, field4: ValueParser<V4>, field5: ValueParser<V5>, field6: ValueParser<V6>, field7: ValueParser<V7>, field8: ValueParser<V8>, field9: ValueParser<V9>): ValueParser<V1 & V2 & V3 & V4 & V5 & V6 & V7 & V8 & V9>;
export declare function compile<Shape>(objectParser: ValueParser<Shape>): {
    parse: (data: Uint8Array) => Shape;
    generate: (obj: Shape) => Uint8Array;
    generateTo: (offset: number, data: Uint8Array, obj: Shape) => number;
};
//# sourceMappingURL=index.d.ts.map